package fr.lri.keller.td4;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.ScrollView;
import android.widget.TextView;

public class ChatActivity extends AppCompatActivity {

    private TextView chat;
    private EditText entry;
    private ScrollView scroll;

    private String chatLog = "";
    private String login;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_chat);
        chat = (TextView) findViewById(R.id.chat);
        entry = (EditText) findViewById(R.id.entry);
        scroll = (ScrollView) findViewById(R.id.scroll);
        Intent data = getIntent();
        login = data.getStringExtra(TD4Activity.EXTRA_LOGIN);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_chat, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    private void displayMessage(String message) {
        // On ajoute ce message a l'ensemble du chat
        chatLog += message;
        // On affiche le chat
        chat.setText(chatLog);
        // On scrolle en bas pour visualiser le dernier message
        scroll.fullScroll(View.FOCUS_DOWN);

    }

    public void enter(View v) {
        // On récupère le texte entré par l'utilisateur
        String text = entry.getText().toString();
        // S'il n'est pas vide
        if (!text.isEmpty()) {
            //On ajoute le login de l'utilisateur avant et un saut de ligne après
            String message = login + ": " + text + "\n";
            // On affiche le message
            displayMessage(message);
            // On nettoie la zone de texte d'entrée
            entry.setText("");
        }
    }

    public void logout(View v) {
        finish();
    }
}
